// made by Mino&Mizo

#include <stdlib.h>
#include <conio.h>


int move1(int score1,int score2,int lastmove);
int move2(int score1,int score2,int lastmove);


#define MaxQueue 110
int queue[MaxQueue];
int top,bottom;

void InitQueue(void)
{ top=0; bottom=0;}

int EmptyQueue(void)
{return top==bottom;}

int FullQueue(void)
{return (top+1)% MaxQueue == bottom;}

void put(int x)
{
  if (FullQueue());
  else {
    queue[top]=x;
    top=(top+1)%MaxQueue;
  }
}

int get(void)
{
  if (EmptyQueue());
  else {
    int pom=queue[bottom];
    return pom;
  }
}

int VHoope, VHoopeSup,
    PredHoop, PredHoopSup,
    NextHoop, NextHoopSup,
    ZlyHoop, ZlyHoopSup,
    Opraveny, OpravenySup;

int PredTah,
    PredTahSup,
    PocetTahov;

const int tab[9][10][2]=
{{{  0,  0},{  0,  0},{  0,  0},{  0,  0},{  0,  0},{  0,  0},{  0,  0},{  0,  0},{ 0, 0},{  0,  0}},
 {{  0,  0},{100,100},{100,100},{100,100},{100,100},{100,100},{100,100},{  0,  0},{ 0, 0},{  0,  0}},
 {{  0,  0},{100,100},{100,100},{100,100},{100,  8},{100,100},{  0,  0},{100,100},{ 0, 0},{100,100}},
 {{  0,  0},{ 20, 20},{  7,  7},{  8,  8},{ 17, 17},{  4,  4},{  2,  2},{ 14, 14},{ 0, 0},{  0,  0}},
 {{  0,  0},{  8,  8},{ 18,  8},{ 27, 17},{ 26, 16},{  2,  2},{  0,  0},{ 13, 13},{22,12},{ 11,  0}},
 {{  0,  0},{  8,  8},{ 18,  8},{ 27, 17},{ 26, 16},{  2,  2},{  0,  0},{ 13, 13},{22,12},{ 11,  0}},
 {{  0,  0},{ 20, 20},{  7,  7},{  8,  8},{ 17, 17},{  4,  4},{  2,  2},{ 14, 14},{ 0, 0},{  0,  0}},
 {{  0,  0},{100,100},{100,100},{100,100},{100,  8},{100,100},{  0,  0},{100,100},{ 0, 0},{100,100}},
 {{  0,  0},{100,100},{100,100},{100,100},{100,100},{100,100},{100,100},{  0,  0},{ 0, 0},{  0,  0}}};


int tabulka(int r, int s, int IncHoop)
{
  return tab[r][s][IncHoop];
}

int VlozDoQueue(int r, int s, int IncHoop)
{ int i;


  InitQueue();
  switch (r) {
    case 1:;
    case 8:
       switch (s){
         case 7:return 6; break;
         case 8:return 4; break;
         case 9:return 2; break;
         case 6:while (!FullQueue) {put(1);put(1);put(8);}
                return 8; break;
         default:
            for (i=s; i<=4; i++) put(1);
            while (!FullQueue) {put(8);put(1);put(1);}
            return 1;
            break;

       }
       break;
    case 2:
    case 7:
       switch (s){
          case 1:
          case 3:
          case 5:
          case 7:
          case 9: while (!FullQueue) put(2);
                  return 2;
                  break;
          case 2:
                  while (!FullQueue) put(2);
                  return 7;
                  break;
          case 8: return 4;
                  break;
          case  6: return 8;
                  break;
          case 4: if (!IncHoop)
                    {
                      put(-2);
                      while (!FullQueue) put(2);
                      return 7;
                    }
                  else {put(8); return 2;}
                  break;
       }
       break;
    case 3:
    case 6:
       switch (s){
         case 1: put(6);put(3);put(8); return 6; break;
         case 2: put(4); return 6; break;
         case 3: put(8);return 3;break;
         case 4: put (6);put(3);put(8);return 3; break;
         case 5: put(4);return 3; break;
         case 6: return 8;
         case 7: put(3);put(8);return 6;
         case 8: return(4);
         case 9: return 2;
       }
       break;
    case 4:
    case 5:
       switch (s){
          case 2: if (!IncHoop) {put(5);put(-4);put(4);put(4);put(8);return 5;}
                  else {put(8); return 4;}
          case 3: if (!IncHoop) {put(4);put(5);put(5);put(-4);put(4);put(4);put(8);return 5;}
                  else {put(4);put(4);put(8); return 5;}
          case 4: if (!IncHoop) {put(4);put( 5);put(5);put(-4);put(4);put(4);put(8);return 4;}
                  else {put(4);put(4);put(8); return 4;}
          case 7: if (!IncHoop) {put(-4);put(4);put(4);put(8);return 5;}
                  else {return 6;}
          case 8: if (!IncHoop) {put(5);put(5);put(-4);put(4);put(4);put(8);return 4;}
                  else {put(4);put(8); return 4;}
          case 9: if (!IncHoop) {put(-5);put(4);put(4);put(8);return 4;}
                  else {return 2;}
          case 6: return 8;
          case 5: put(2); return 4;
          case 1: put(8); return 5;
       }
    break;
  } //end of switch

}

int mozem(int x)
{
  return ((x!=PredTahSup)&&(x!=9-PredTahSup))||(VHoopeSup);
}

int BackBelowHoop(int score1, int score2)
{
  return -8;
}

int NormalMove(int score1, int score2)
{
  int zisk,tah;

  switch (score1 % 10){
    case 1: if (mozem(6)) tah=6;
            else tah=4;
            break;
    case 2: if (mozem(7)) tah=7;
            else tah=1;
            break;
    case 3: if (mozem(5)) tah=5;
            else tah=1;
            break;
    case 4: if (mozem(3)) tah=3;
            else tah=4;
            break;
    case 5: if (mozem(1)) tah=1;
            else tah=2;
            break;
    case 6: if (mozem(8)) tah=8;
            else tah=4;
            break;
    case 7: if (mozem(6)) tah=6;
            else tah=2;
            break;
    case 8: if (mozem(4)) tah=4;
            else tah=6;
            break;
    case 9: if (mozem(2)) tah=2;
            else tah=4;
            break;
    case 0: if (mozem(7)) tah=7;
            else tah=5;
            break;
  }
  zisk=tah;
  if ((NextHoop-score1<8)&&(NextHoop-score1!=6)&&(!VHoopeSup)
      &&(PredTahSup!=NextHoop-score1)&&(NextHoop-score1!=9-PredTahSup)
      && !((ZlyHoopSup)&&(!OpravenySup)))
   {
     zisk=NextHoop-score1-tabulka(NextHoop-score1,score2 % 10,ZlyHoopSup);
     if ((zisk>tah)&&(NextHoop-score1!=6))
        tah=NextHoop-score1;
   }
  if (VHoopeSup) {
    zisk=tabulka(PredTahSup, score1 % 10, ZlyHoop);
    if (zisk>tah)
      tah=VlozDoQueue(PredTahSup, score1%10, ZlyHoop);
  }
  return tah;
}

int move1(int score1,int score2, int lastmove)
{
  if (!lastmove) ; //nechcem
  else {PredTahSup=abs(lastmove);};

  if (!score1)
    {
      InitQueue();
      PredTah=-9;
      PocetTahov=0;
      PredTahSup=0;
      ZlyHoop=0;
      ZlyHoopSup=0;
      Opraveny=0;
      OpravenySup=0;
    }
  PocetTahov++;

  if (!EmptyQueue)
    {PredTah=get();
     if (PredTah<0) ZlyHoop=1;
     return PredTah;
    }

    VHoope=(score1 % 10 == 0)&&(score1>0);
    VHoopeSup=(score2 % 10 == 0)&&(score2>0);
    PredHoop=(score1/10)*10;
    PredHoopSup=(score2/10)*10;
    NextHoop=(score1/10+1)*10;
    NextHoopSup=(score2/10+1)*10;
    ZlyHoop=ZlyHoop||((score1>PredHoop)&&(score1-PredTah<PredHoop)
                      &&(score1-PredHoop!=PredHoop-(score1-PredTah)));
    OpravenySup=OpravenySup||ZlyHoopSup;
    ZlyHoopSup=ZlyHoopSup || ((score2>PredHoopSup)&&(score2-PredTahSup<
                              PredHoopSup)&&(score2-PredHoopSup!=PredHoopSup-
                              (score2-PredTahSup)));

    if (VHoope)
      if ((!VHoopeSup)&&((PredTahSup==PredTah)||(9-PredTahSup==PredTah)))
        return 0;
      else return PredTah;
    else //I"m not ina hoop
      if (ZlyHoop&&!Opraveny)
        {
          Opraveny=1;
          PredTah=BackBelowHoop(score1,score2);
          return PredTah;
        }
      else {
         PredTah=NormalMove(score1,score2);
         return PredTah;
      }
}

int move2(int score1,int score2, int lastmove)
{
  return move1(score2, score1, lastmove);
}

